/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file Cache_blob_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'cache_blob.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJTOOLS_DATA_LOADERS_ASN_CACHE_CACHE_BLOB_BASE_HPP
#define OBJTOOLS_DATA_LOADERS_ASN_CACHE_CACHE_BLOB_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <vector>

BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CCache_blob_Base : public CSerialObject
{
    typedef CSerialObject Tparent;
public:
    // constructor
    CCache_blob_Base(void);
    // destructor
    virtual ~CCache_blob_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    // types
    typedef int TMagic;
    typedef int TTimestamp;
    typedef vector< char > TBlob;
    typedef vector< char > TMd5_digest;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_magic,
        e_timestamp,
        e_blob,
        e_md5_digest
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 5> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef int TMagic
    ///  Check whether the Magic data member has been assigned a value.
    bool IsSetMagic(void) const;
    /// Check whether it is safe or not to call GetMagic method.
    bool CanGetMagic(void) const;
    void ResetMagic(void);
    TMagic GetMagic(void) const;
    void SetMagic(TMagic value);
    TMagic& SetMagic(void);

    /// mandatory
    /// typedef int TTimestamp
    ///  Check whether the Timestamp data member has been assigned a value.
    bool IsSetTimestamp(void) const;
    /// Check whether it is safe or not to call GetTimestamp method.
    bool CanGetTimestamp(void) const;
    void ResetTimestamp(void);
    TTimestamp GetTimestamp(void) const;
    void SetTimestamp(TTimestamp value);
    TTimestamp& SetTimestamp(void);

    /// mandatory
    /// typedef vector< char > TBlob
    ///  Check whether the Blob data member has been assigned a value.
    bool IsSetBlob(void) const;
    /// Check whether it is safe or not to call GetBlob method.
    bool CanGetBlob(void) const;
    void ResetBlob(void);
    const TBlob& GetBlob(void) const;
    TBlob& SetBlob(void);

    /// mandatory
    /// typedef vector< char > TMd5_digest
    ///  Check whether the Md5_digest data member has been assigned a value.
    bool IsSetMd5_digest(void) const;
    /// Check whether it is safe or not to call GetMd5_digest method.
    bool CanGetMd5_digest(void) const;
    void ResetMd5_digest(void);
    const TMd5_digest& GetMd5_digest(void) const;
    TMd5_digest& SetMd5_digest(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCache_blob_Base(const CCache_blob_Base&);
    CCache_blob_Base& operator=(const CCache_blob_Base&);

    // data
    Uint4 m_set_State[1];
    int m_Magic;
    int m_Timestamp;
    vector< char > m_Blob;
    vector< char > m_Md5_digest;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCache_blob_Base::IsSetMagic(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCache_blob_Base::CanGetMagic(void) const
{
    return IsSetMagic();
}

inline
void CCache_blob_Base::ResetMagic(void)
{
    m_Magic = 0;
    m_set_State[0] &= ~0x3;
}

inline
CCache_blob_Base::TMagic CCache_blob_Base::GetMagic(void) const
{
    if (!CanGetMagic()) {
        ThrowUnassigned(0);
    }
    return m_Magic;
}

inline
void CCache_blob_Base::SetMagic(CCache_blob_Base::TMagic value)
{
    m_Magic = value;
    m_set_State[0] |= 0x3;
}

inline
CCache_blob_Base::TMagic& CCache_blob_Base::SetMagic(void)
{
#ifdef _DEBUG
    if (!IsSetMagic()) {
        memset(&m_Magic,UnassignedByte(),sizeof(m_Magic));
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Magic;
}

inline
bool CCache_blob_Base::IsSetTimestamp(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CCache_blob_Base::CanGetTimestamp(void) const
{
    return IsSetTimestamp();
}

inline
void CCache_blob_Base::ResetTimestamp(void)
{
    m_Timestamp = 0;
    m_set_State[0] &= ~0xc;
}

inline
CCache_blob_Base::TTimestamp CCache_blob_Base::GetTimestamp(void) const
{
    if (!CanGetTimestamp()) {
        ThrowUnassigned(1);
    }
    return m_Timestamp;
}

inline
void CCache_blob_Base::SetTimestamp(CCache_blob_Base::TTimestamp value)
{
    m_Timestamp = value;
    m_set_State[0] |= 0xc;
}

inline
CCache_blob_Base::TTimestamp& CCache_blob_Base::SetTimestamp(void)
{
#ifdef _DEBUG
    if (!IsSetTimestamp()) {
        memset(&m_Timestamp,UnassignedByte(),sizeof(m_Timestamp));
    }
#endif
    m_set_State[0] |= 0x4;
    return m_Timestamp;
}

inline
bool CCache_blob_Base::IsSetBlob(void) const
{
    return ((m_set_State[0] & 0x30) != 0);
}

inline
bool CCache_blob_Base::CanGetBlob(void) const
{
    return IsSetBlob();
}

inline
const CCache_blob_Base::TBlob& CCache_blob_Base::GetBlob(void) const
{
    if (!CanGetBlob()) {
        ThrowUnassigned(2);
    }
    return m_Blob;
}

inline
CCache_blob_Base::TBlob& CCache_blob_Base::SetBlob(void)
{
    m_set_State[0] |= 0x10;
    return m_Blob;
}

inline
bool CCache_blob_Base::IsSetMd5_digest(void) const
{
    return ((m_set_State[0] & 0xc0) != 0);
}

inline
bool CCache_blob_Base::CanGetMd5_digest(void) const
{
    return IsSetMd5_digest();
}

inline
const CCache_blob_Base::TMd5_digest& CCache_blob_Base::GetMd5_digest(void) const
{
    if (!CanGetMd5_digest()) {
        ThrowUnassigned(3);
    }
    return m_Md5_digest;
}

inline
CCache_blob_Base::TMd5_digest& CCache_blob_Base::SetMd5_digest(void)
{
    m_set_State[0] |= 0x40;
    return m_Md5_digest;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJTOOLS_DATA_LOADERS_ASN_CACHE_CACHE_BLOB_BASE_HPP
