/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file CollectiveName_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'efetch.xsd'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef eutils__OBJTOOLS_EUTILS_EFETCH_COLLECTIVENAME_BASE_HPP
#define eutils__OBJTOOLS_EUTILS_EFETCH_COLLECTIVENAME_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>

// generated includes
#include <list>
#include <string>
#include <objtools/eutils/efetch/Text.hpp>

#ifndef BEGIN_eutils_SCOPE
#  define BEGIN_eutils_SCOPE BEGIN_SCOPE(eutils)
#  define END_eutils_SCOPE END_SCOPE(eutils)
#endif
BEGIN_eutils_SCOPE // namespace eutils::


// generated classes

/////////////////////////////////////////////////////////////////////////////
class CCollectiveName_Base : public NCBI_NS_NCBI::CSerialObject
{
    typedef NCBI_NS_NCBI::CSerialObject Tparent;
public:
    // constructor
    CCollectiveName_Base(void);
    // destructor
    virtual ~CCollectiveName_Base(void);

    // type info
    DECLARE_INTERNAL_TYPE_INFO();

    /////////////////////////////////////////////////////////////////////////////
    class C_Attlist : public NCBI_NS_NCBI::CSerialObject
    {
        typedef NCBI_NS_NCBI::CSerialObject Tparent;
    public:
        // constructor
        C_Attlist(void);
        // destructor
        ~C_Attlist(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        // types
        typedef NCBI_NS_STD::string TInvestigators;
    
        // member index
        enum class E_memberIndex {
            e__allMandatory = 0,
            e_Investigators
        };
        typedef Tparent::CMemberIndex<E_memberIndex, 2> TmemberIndex;
    
        // getters
        // setters
    
        /// optional
        /// typedef NCBI_NS_STD::string TInvestigators
        ///  Check whether the Investigators data member has been assigned a value.
        bool IsSetInvestigators(void) const;
        /// Check whether it is safe or not to call GetInvestigators method.
        bool CanGetInvestigators(void) const;
        void ResetInvestigators(void);
        const TInvestigators& GetInvestigators(void) const;
        void SetInvestigators(const TInvestigators& value);
        void SetInvestigators(TInvestigators&& value);
        TInvestigators& SetInvestigators(void);
    
        /// Reset the whole object
        void Reset(void);
    
    
    private:
        // Prohibit copy constructor and assignment operator
        C_Attlist(const C_Attlist&);
        C_Attlist& operator=(const C_Attlist&);
    
        // data
        Uint4 m_set_State[1];
        NCBI_NS_STD::string m_Investigators;
    };
    /////////////////////////////////////////////////////////////////////////////
    class C_E_CollectiveName : public NCBI_NS_NCBI::CSerialObject
    {
        typedef NCBI_NS_NCBI::CSerialObject Tparent;
    public:
        // constructor
        C_E_CollectiveName(void);
        // destructor
        ~C_E_CollectiveName(void);
    
        // type info
        DECLARE_INTERNAL_TYPE_INFO();
    
        typedef CText C_Text;
    
        /// Choice variants.
        enum E_Choice {
            e_not_set = 0,  ///< No variant selected
            e__CharData,
            e_Text
        };
        /// Maximum+1 value of the choice variant enumerator.
        enum E_ChoiceStopper {
            e_MaxChoice = 3 ///< == e_Text+1
        };
    
        /// Reset the whole object
        void Reset(void);
    
        /// Reset the selection (set it to e_not_set).
        void ResetSelection(void);
    
        /// Which variant is currently selected.
        E_Choice Which(void) const;
    
        /// Verify selection, throw exception if it differs from the expected.
        void CheckSelected(E_Choice index) const;
    
        /// Throw 'InvalidSelection' exception.
        NCBI_NORETURN void ThrowInvalidSelection(E_Choice index) const;
    
        /// Retrieve selection name (for diagnostic purposes).
        static NCBI_NS_STD::string SelectionName(E_Choice index);
    
        /// Select the requested variant if needed.
        void Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset = NCBI_NS_NCBI::eDoResetVariant);
        /// Select the requested variant if needed,
        /// allocating CObject variants from memory pool.
        void Select(E_Choice index,
                    NCBI_NS_NCBI::EResetVariant reset,
                    NCBI_NS_NCBI::CObjectMemoryPool* pool);
    
        // types
        typedef NCBI_NS_STD::string T_CharData;
        typedef C_Text TText;
    
        // getters
        // setters
    
        // typedef NCBI_NS_STD::string T_CharData
        bool Is_CharData(void) const;
        const T_CharData& Get_CharData(void) const;
        T_CharData& Set_CharData(void);
        void Set_CharData(const T_CharData& value);
    
        // typedef C_Text TText
        bool IsText(void) const;
        const TText& GetText(void) const;
        TText& SetText(void);
        void SetText(TText& value);
    
    
    private:
        // copy constructor and assignment operator
        C_E_CollectiveName(const C_E_CollectiveName& );
        C_E_CollectiveName& operator=(const C_E_CollectiveName& );
        // choice state
        E_Choice m_choice;
        // helper methods
        void DoSelect(E_Choice index, NCBI_NS_NCBI::CObjectMemoryPool* pool = 0);
    
        static const char* const sm_SelectionNames[];
        // data
        union {
            NCBI_NS_NCBI::CUnionBuffer<NCBI_NS_STD::string> m_string;
            NCBI_NS_NCBI::CSerialObject *m_object;
        };
    };
    // types
    typedef C_Attlist TAttlist;
    typedef C_E_CollectiveName C_E;
    typedef NCBI_NS_STD::list< NCBI_NS_NCBI::CRef< C_E_CollectiveName > > TCollectiveName;

    // member index
    enum class E_memberIndex {
        e__allMandatory = 0,
        e_Attlist,
        e_CollectiveName
    };
    typedef Tparent::CMemberIndex<E_memberIndex, 3> TmemberIndex;

    // getters
    // setters

    /// mandatory
    /// typedef C_Attlist TAttlist
    ///  Check whether the Attlist data member has been assigned a value.
    bool IsSetAttlist(void) const;
    /// Check whether it is safe or not to call GetAttlist method.
    bool CanGetAttlist(void) const;
    void ResetAttlist(void);
    const TAttlist& GetAttlist(void) const;
    void SetAttlist(TAttlist& value);
    TAttlist& SetAttlist(void);

    /// optional
    /// typedef NCBI_NS_STD::list< NCBI_NS_NCBI::CRef< C_E_CollectiveName > > TCollectiveName
    ///  Check whether the CollectiveName data member has been assigned a value.
    bool IsSetCollectiveName(void) const;
    /// Check whether it is safe or not to call GetCollectiveName method.
    bool CanGetCollectiveName(void) const;
    void ResetCollectiveName(void);
    const TCollectiveName& GetCollectiveName(void) const;
    TCollectiveName& SetCollectiveName(void);

    /// Reset the whole object
    virtual void Reset(void);


private:
    // Prohibit copy constructor and assignment operator
    CCollectiveName_Base(const CCollectiveName_Base&);
    CCollectiveName_Base& operator=(const CCollectiveName_Base&);

    // data
    Uint4 m_set_State[1];
    NCBI_NS_NCBI::CRef< TAttlist > m_Attlist;
    NCBI_NS_STD::list< NCBI_NS_NCBI::CRef< C_E_CollectiveName > > m_CollectiveName;
};






///////////////////////////////////////////////////////////
///////////////////// inline methods //////////////////////
///////////////////////////////////////////////////////////
inline
bool CCollectiveName_Base::C_Attlist::IsSetInvestigators(void) const
{
    return ((m_set_State[0] & 0x3) != 0);
}

inline
bool CCollectiveName_Base::C_Attlist::CanGetInvestigators(void) const
{
    return IsSetInvestigators();
}

inline
const CCollectiveName_Base::C_Attlist::TInvestigators& CCollectiveName_Base::C_Attlist::GetInvestigators(void) const
{
    if (!CanGetInvestigators()) {
        ThrowUnassigned(0);
    }
    return m_Investigators;
}

inline
void CCollectiveName_Base::C_Attlist::SetInvestigators(const CCollectiveName_Base::C_Attlist::TInvestigators& value)
{
    m_Investigators = value;
    m_set_State[0] |= 0x3;
}

inline
void CCollectiveName_Base::C_Attlist::SetInvestigators(CCollectiveName_Base::C_Attlist::TInvestigators&& value)
{
    m_Investigators = std::forward<CCollectiveName_Base::C_Attlist::TInvestigators>(value);
    m_set_State[0] |= 0x3;
}

inline
CCollectiveName_Base::C_Attlist::TInvestigators& CCollectiveName_Base::C_Attlist::SetInvestigators(void)
{
#ifdef _DEBUG
    if (!IsSetInvestigators()) {
        m_Investigators = UnassignedString();
    }
#endif
    m_set_State[0] |= 0x1;
    return m_Investigators;
}

inline
CCollectiveName_Base::C_E_CollectiveName::E_Choice CCollectiveName_Base::C_E_CollectiveName::Which(void) const
{
    return m_choice;
}

inline
void CCollectiveName_Base::C_E_CollectiveName::CheckSelected(E_Choice index) const
{
    if ( m_choice != index )
        ThrowInvalidSelection(index);
}

inline
void CCollectiveName_Base::C_E_CollectiveName::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    if ( reset == NCBI_NS_NCBI::eDoResetVariant || m_choice != index ) {
        if ( m_choice != e_not_set )
            ResetSelection();
        DoSelect(index, pool);
    }
}

inline
void CCollectiveName_Base::C_E_CollectiveName::Select(E_Choice index, NCBI_NS_NCBI::EResetVariant reset)
{
    Select(index, reset, 0);
}

inline
bool CCollectiveName_Base::C_E_CollectiveName::Is_CharData(void) const
{
    return m_choice == e__CharData;
}

inline
const CCollectiveName_Base::C_E_CollectiveName::T_CharData& CCollectiveName_Base::C_E_CollectiveName::Get_CharData(void) const
{
    CheckSelected(e__CharData);
    return *m_string;
}

inline
CCollectiveName_Base::C_E_CollectiveName::T_CharData& CCollectiveName_Base::C_E_CollectiveName::Set_CharData(void)
{
    Select(e__CharData, NCBI_NS_NCBI::eDoNotResetVariant);
    return *m_string;
}

inline
bool CCollectiveName_Base::C_E_CollectiveName::IsText(void) const
{
    return m_choice == e_Text;
}

inline
bool CCollectiveName_Base::IsSetAttlist(void) const
{
    return m_Attlist.NotEmpty();
}

inline
bool CCollectiveName_Base::CanGetAttlist(void) const
{
    return true;
}

inline
const CCollectiveName_Base::TAttlist& CCollectiveName_Base::GetAttlist(void) const
{
    if ( !m_Attlist ) {
        const_cast<CCollectiveName_Base*>(this)->ResetAttlist();
    }
    return (*m_Attlist);
}

inline
CCollectiveName_Base::TAttlist& CCollectiveName_Base::SetAttlist(void)
{
    if ( !m_Attlist ) {
        ResetAttlist();
    }
    return (*m_Attlist);
}

inline
bool CCollectiveName_Base::IsSetCollectiveName(void) const
{
    return ((m_set_State[0] & 0xc) != 0);
}

inline
bool CCollectiveName_Base::CanGetCollectiveName(void) const
{
    return true;
}

inline
const CCollectiveName_Base::TCollectiveName& CCollectiveName_Base::GetCollectiveName(void) const
{
    return m_CollectiveName;
}

inline
CCollectiveName_Base::TCollectiveName& CCollectiveName_Base::SetCollectiveName(void)
{
    m_set_State[0] |= 0x4;
    return m_CollectiveName;
}

///////////////////////////////////////////////////////////
////////////////// end of inline methods //////////////////
///////////////////////////////////////////////////////////





END_eutils_SCOPE // namespace eutils::


#endif // eutils__OBJTOOLS_EUTILS_EFETCH_COLLECTIVENAME_BASE_HPP
